Index: /trunk/SophyaPI/PI/Makefile
===================================================================
--- /trunk/SophyaPI/PI/Makefile	(revision 155)
+++ /trunk/SophyaPI/PI/Makefile	(revision 156)
@@ -17,17 +17,16 @@
 endif 
  
-$(OBJ)lut.o: lut.cc $(INC)defs.h \
+$(OBJ)lut.o: lut.cc $(INC)defs.h lut.h
+$(OBJ)parradapter.o: parradapter.cc parradapter.h \
+ $(INC)defs.h $(INC)machine.h \
  lut.h
-$(OBJ)parradapter.o: parradapter.cc parradapter.h \
- $(INC)defs.h \
- $(INC)machine.h lut.h
 $(OBJ)pi3ddrw.o: pi3ddrw.cc pi3ddrw.h pisysdep.h pidrawer.h pibwdggen.h \
  piwdgx.h piwdggen.h pimsghandler.h picmap.h picmapx.h picmapgen.h \
  pigraphx.h pigraphgen.h pigraphuc.h psfile.h \
- $(INC)defs.h pigraph3d.h \
- pibwdgx.h pigraphps.h pidrwtools.h pistdwdgx.h pistdwdggen.h \
- pioptmenux.h pioptmenugen.h pimenux.h pimenugen.h piwindowx.h \
- piwindowgen.h picontainerx.h picontainergen.h piapplx.h piapplgen.h \
- pimenubarx.h pimenubargen.h picons.h
+ $(INC)defs.h pigraph3d.h pibwdgx.h pigraphps.h \
+ pidrwtools.h pistdwdgx.h pistdwdggen.h pioptmenux.h pioptmenugen.h \
+ pimenux.h pimenugen.h piwindowx.h piwindowgen.h picontainerx.h \
+ picontainergen.h piapplx.h piapplgen.h pimenubarx.h pimenubargen.h \
+ picons.h
 $(OBJ)piapplgen.o: piapplgen.cc piapplgen.h pimsghandler.h pisysdep.h \
  picontainerx.h picontainergen.h piwdgx.h piwdggen.h pimenubarx.h \
@@ -44,6 +43,5 @@
 $(OBJ)pibwdggen.o: pibwdggen.cc pibwdggen.h pisysdep.h piwdgx.h piwdggen.h \
  pimsghandler.h picmap.h picmapx.h picmapgen.h pigraphx.h pigraphgen.h \
- pigraphuc.h psfile.h \
- $(INC)defs.h pidrawer.h \
+ pigraphuc.h psfile.h $(INC)defs.h pidrawer.h \
  pigraphps.h pidrwtools.h pistdwdgx.h pistdwdggen.h pioptmenux.h \
  pioptmenugen.h pimenux.h pimenugen.h piwindowx.h piwindowgen.h \
@@ -53,6 +51,5 @@
  piwdgx.h piwdggen.h pimsghandler.h picmap.h picmapx.h picmapgen.h \
  pigraphx.h pigraphgen.h pigraphuc.h psfile.h \
- $(INC)defs.h pigraphps.h \
- pixtbase.h
+ $(INC)defs.h pigraphps.h pixtbase.h
 $(OBJ)picmap.o: picmap.cc picmap.h pisysdep.h picmapx.h picmapgen.h
 $(OBJ)picmapgen.o: picmapgen.cc picmapgen.h pisysdep.h picmapx.h picmap.h
@@ -74,12 +71,11 @@
 $(OBJ)pidrawer.o: pidrawer.cc pidrawer.h pibwdggen.h pisysdep.h piwdgx.h \
  piwdggen.h pimsghandler.h picmap.h picmapx.h picmapgen.h pigraphx.h \
- pigraphgen.h pigraphuc.h psfile.h \
- $(INC)defs.h
+ pigraphgen.h pigraphuc.h psfile.h $(INC)defs.h
 $(OBJ)pidrawwin.o: pidrawwin.cc pidrawwin.h pisysdep.h piwindowx.h \
  piwindowgen.h picontainerx.h picontainergen.h piwdgx.h piwdggen.h \
  pimsghandler.h piscdrawwdg.h pibwdgx.h pibwdggen.h picmap.h picmapx.h \
  picmapgen.h pigraphx.h pigraphgen.h pigraphuc.h psfile.h \
- $(INC)defs.h pigraphps.h \
- pistdwdgx.h pistdwdggen.h pidrawer.h
+ $(INC)defs.h pigraphps.h pistdwdgx.h \
+ pistdwdggen.h pidrawer.h
 $(OBJ)pidrwtools.o: pidrwtools.cc pidrwtools.h pisysdep.h pistdwdgx.h \
  pistdwdggen.h piwdgx.h piwdggen.h pimsghandler.h pioptmenux.h \
@@ -88,6 +84,6 @@
  pimenubargen.h picons.h pibwdgx.h pibwdggen.h picmap.h picmapx.h \
  picmapgen.h pigraphx.h pigraphgen.h pigraphuc.h psfile.h \
- $(INC)defs.h pigraphps.h \
- piscdrawwdg.h pidrawer.h pi3ddrw.h pigraph3d.h
+ $(INC)defs.h pigraphps.h piscdrawwdg.h pidrawer.h \
+ pi3ddrw.h pigraph3d.h
 $(OBJ)pifilechogen.o: pifilechogen.cc pifilechogen.h pisysdep.h piwdgx.h \
  piwdggen.h pimsghandler.h
@@ -97,8 +93,7 @@
  pistdwdgx.h pistdwdggen.h pibwdgx.h pibwdggen.h picmap.h picmapx.h \
  picmapgen.h pigraphx.h pigraphgen.h pigraphuc.h psfile.h \
- $(INC)defs.h pigraphps.h \
- pifilechox.h pifilechogen.h piwindowx.h piwindowgen.h
-$(OBJ)pigfd1.o: pigfd1.cc pigfd1.h \
- $(INC)generaldata.h \
+ $(INC)defs.h pigraphps.h pifilechox.h \
+ pifilechogen.h piwindowx.h piwindowgen.h
+$(OBJ)pigfd1.o: pigfd1.cc pigfd1.h $(INC)generaldata.h \
  $(INC)exceptions.h \
  $(INC)defs.h \
@@ -108,14 +103,11 @@
  $(INC)perrors.h \
  $(INC)pclassids.h \
- $(INC)poly.h \
- $(INC)peida.h \
- $(INC)utils.h \
- $(INC)fmath.h \
- $(INC)cvector.h \
- $(INC)matrix.h pidrawer.h \
- pibwdggen.h pisysdep.h piwdgx.h piwdggen.h pimsghandler.h picmap.h \
- picmapx.h picmapgen.h pigraphx.h pigraphgen.h pigraphuc.h psfile.h
-$(OBJ)pigfd2.o: pigfd2.cc pigfd2.h \
- $(INC)generaldata.h \
+ $(INC)poly.h $(INC)peida.h \
+ $(INC)utils.h $(INC)fmath.h \
+ $(INC)cvector.h \
+ $(INC)matrix.h pidrawer.h pibwdggen.h pisysdep.h \
+ piwdgx.h piwdggen.h pimsghandler.h picmap.h picmapx.h picmapgen.h \
+ pigraphx.h pigraphgen.h pigraphuc.h psfile.h
+$(OBJ)pigfd2.o: pigfd2.cc pigfd2.h $(INC)generaldata.h \
  $(INC)exceptions.h \
  $(INC)defs.h \
@@ -125,13 +117,11 @@
  $(INC)perrors.h \
  $(INC)pclassids.h \
- $(INC)poly.h \
- $(INC)peida.h \
- $(INC)utils.h \
- $(INC)fmath.h \
- $(INC)cvector.h \
- $(INC)matrix.h pi3ddrw.h \
- pisysdep.h pidrawer.h pibwdggen.h piwdgx.h piwdggen.h pimsghandler.h \
- picmap.h picmapx.h picmapgen.h pigraphx.h pigraphgen.h pigraphuc.h \
- psfile.h pigraph3d.h pibwdgx.h pigraphps.h
+ $(INC)poly.h $(INC)peida.h \
+ $(INC)utils.h $(INC)fmath.h \
+ $(INC)cvector.h \
+ $(INC)matrix.h pi3ddrw.h pisysdep.h pidrawer.h \
+ pibwdggen.h piwdgx.h piwdggen.h pimsghandler.h picmap.h picmapx.h \
+ picmapgen.h pigraphx.h pigraphgen.h pigraphuc.h psfile.h pigraph3d.h \
+ pibwdgx.h pigraphps.h
 $(OBJ)pigraph3d.o: pigraph3d.cc pigraph3d.h pisysdep.h pigraphuc.h \
  pigraphgen.h piwdgx.h piwdggen.h pimsghandler.h picmap.h picmapx.h \
@@ -146,20 +136,16 @@
 $(OBJ)pigraphx.o: pigraphx.cc pigraphx.h pisysdep.h pigraphgen.h piwdgx.h \
  piwdggen.h pimsghandler.h picmap.h picmapx.h picmapgen.h
-$(OBJ)pihisto.o: pihisto.cc pihisto.h \
- $(INC)histos.h \
- $(INC)peida.h \
- $(INC)defs.h \
- $(INC)utils.h \
- $(INC)machine.h \
- $(INC)perrors.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h \
- $(INC)fmath.h \
- $(INC)cvector.h \
+$(OBJ)pihisto.o: pihisto.cc pihisto.h $(INC)histos.h \
+ $(INC)peida.h $(INC)defs.h \
+ $(INC)utils.h $(INC)machine.h \
+ $(INC)perrors.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h \
+ $(INC)fmath.h $(INC)cvector.h \
  $(INC)matrix.h \
  $(INC)ppersist.h \
- $(INC)pclassids.h pidrawer.h \
- pibwdggen.h pisysdep.h piwdgx.h piwdggen.h pimsghandler.h picmap.h \
- picmapx.h picmapgen.h pigraphx.h pigraphgen.h pigraphuc.h psfile.h \
+ $(INC)pclassids.h pidrawer.h pibwdggen.h \
+ pisysdep.h piwdgx.h piwdggen.h pimsghandler.h picmap.h picmapx.h \
+ picmapgen.h pigraphx.h pigraphgen.h pigraphuc.h psfile.h \
  $(INC)hisprof.h
 $(OBJ)pihisto2d.o: pihisto2d.cc piapplgen.h pimsghandler.h pisysdep.h \
@@ -168,28 +154,23 @@
  pistdwdggen.h pibwdgx.h pibwdggen.h picmap.h picmapx.h picmapgen.h \
  pigraphx.h pigraphgen.h pigraphuc.h psfile.h \
- $(INC)defs.h pigraphps.h \
- pihisto2d.h pioptmenux.h pioptmenugen.h \
- $(INC)histos2.h \
- $(INC)peida.h \
- $(INC)utils.h \
- $(INC)machine.h \
- $(INC)perrors.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h \
- $(INC)fmath.h \
- $(INC)histos.h \
+ $(INC)defs.h pigraphps.h pihisto2d.h pioptmenux.h \
+ pioptmenugen.h $(INC)histos2.h \
+ $(INC)peida.h $(INC)utils.h \
+ $(INC)machine.h \
+ $(INC)perrors.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h \
+ $(INC)fmath.h $(INC)histos.h \
  $(INC)cvector.h \
  $(INC)matrix.h \
  $(INC)ppersist.h \
- $(INC)pclassids.h \
- piscdrawwdg.h piwindowx.h piwindowgen.h pidrawer.h \
- $(INC)nbrandom.h
+ $(INC)pclassids.h piscdrawwdg.h piwindowx.h \
+ piwindowgen.h pidrawer.h $(INC)nbrandom.h
 $(OBJ)piimage.o: piimage.cc piimage.h parradapter.h \
- $(INC)defs.h \
- $(INC)machine.h lut.h \
- pisysdep.h pidrawer.h pibwdggen.h piwdgx.h piwdggen.h pimsghandler.h \
- picmap.h picmapx.h picmapgen.h pigraphx.h pigraphgen.h pigraphuc.h \
- psfile.h pipixmapx.h pipixmapgen.h pibwdgx.h pigraphps.h pistdwdgx.h \
- pistdwdggen.h piwindowx.h piwindowgen.h picontainerx.h \
+ $(INC)defs.h $(INC)machine.h \
+ lut.h pisysdep.h pidrawer.h pibwdggen.h piwdgx.h piwdggen.h \
+ pimsghandler.h picmap.h picmapx.h picmapgen.h pigraphx.h pigraphgen.h \
+ pigraphuc.h psfile.h pipixmapx.h pipixmapgen.h pibwdgx.h pigraphps.h \
+ pistdwdgx.h pistdwdggen.h piwindowx.h piwindowgen.h picontainerx.h \
  picontainergen.h picmapview.h piimgtools.h pioptmenux.h \
  pioptmenugen.h pimenux.h pimenugen.h piapplx.h piapplgen.h \
@@ -201,10 +182,8 @@
  pimenubargen.h picons.h pibwdgx.h pibwdggen.h picmap.h picmapx.h \
  picmapgen.h pigraphx.h pigraphgen.h pigraphuc.h psfile.h \
- $(INC)defs.h pigraphps.h \
- piimage.h parradapter.h \
- $(INC)machine.h lut.h \
- pidrawer.h pipixmapx.h pipixmapgen.h picmapview.h
-$(OBJ)piinit.o: piinit.cc \
- $(INC)defs.h piinit.h \
+ $(INC)defs.h pigraphps.h piimage.h parradapter.h \
+ $(INC)machine.h lut.h pidrawer.h pipixmapx.h \
+ pipixmapgen.h picmapview.h
+$(OBJ)piinit.o: piinit.cc $(INC)defs.h piinit.h \
  $(INC)strecinit.h \
  $(INC)imaginit.h \
@@ -231,29 +210,25 @@
  pimenugen.h piwdgx.h piwdggen.h pimsghandler.h
 $(OBJ)pimsghandler.o: pimsghandler.cc pimsghandler.h
-$(OBJ)pintup3d.o: pintup3d.cc pintup3d.h \
- $(INC)ntuple.h \
- $(INC)ppersist.h \
- $(INC)defs.h \
- $(INC)machine.h \
- $(INC)perrors.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h \
- $(INC)pclassids.h \
- $(INC)dvlist.h pi3ddrw.h \
- pisysdep.h pidrawer.h pibwdggen.h piwdgx.h piwdggen.h pimsghandler.h \
- picmap.h picmapx.h picmapgen.h pigraphx.h pigraphgen.h pigraphuc.h \
- psfile.h pigraph3d.h pibwdgx.h pigraphps.h
-$(OBJ)pintuple.o: pintuple.cc pintuple.h \
- $(INC)ntuple.h \
- $(INC)ppersist.h \
- $(INC)defs.h \
- $(INC)machine.h \
- $(INC)perrors.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h \
- $(INC)pclassids.h \
- $(INC)dvlist.h pidrawer.h \
- pibwdggen.h pisysdep.h piwdgx.h piwdggen.h pimsghandler.h picmap.h \
- picmapx.h picmapgen.h pigraphx.h pigraphgen.h pigraphuc.h psfile.h
+$(OBJ)pintup3d.o: pintup3d.cc pintup3d.h $(INC)ntuple.h \
+ $(INC)ppersist.h $(INC)defs.h \
+ $(INC)machine.h \
+ $(INC)perrors.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h \
+ $(INC)pclassids.h \
+ $(INC)dvlist.h pi3ddrw.h pisysdep.h pidrawer.h \
+ pibwdggen.h piwdgx.h piwdggen.h pimsghandler.h picmap.h picmapx.h \
+ picmapgen.h pigraphx.h pigraphgen.h pigraphuc.h psfile.h pigraph3d.h \
+ pibwdgx.h pigraphps.h
+$(OBJ)pintuple.o: pintuple.cc pintuple.h $(INC)ntuple.h \
+ $(INC)ppersist.h $(INC)defs.h \
+ $(INC)machine.h \
+ $(INC)perrors.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h \
+ $(INC)pclassids.h \
+ $(INC)dvlist.h pidrawer.h pibwdggen.h pisysdep.h \
+ piwdgx.h piwdggen.h pimsghandler.h picmap.h picmapx.h picmapgen.h \
+ pigraphx.h pigraphgen.h pigraphuc.h psfile.h
 $(OBJ)pioptmenugen.o: pioptmenugen.cc pioptmenugen.h pisysdep.h pimenux.h \
  pimenugen.h piwdgx.h piwdggen.h pimsghandler.h
@@ -281,8 +256,6 @@
  $(INC)machine.h lut.h \
  $(INC)cvector.h \
- $(INC)matrix.h \
- $(INC)peida.h \
- $(INC)utils.h \
- $(INC)perrors.h \
+ $(INC)matrix.h $(INC)peida.h \
+ $(INC)utils.h $(INC)perrors.h \
  $(INC)exceptions.h \
  $(INC)peidainit.h \
@@ -298,6 +271,6 @@
  pibwdggen.h piwdgx.h piwdggen.h pimsghandler.h picmap.h picmapx.h \
  picmapgen.h pigraphx.h pigraphgen.h pigraphuc.h psfile.h \
- $(INC)defs.h pigraphps.h \
- pistdwdgx.h pistdwdggen.h piwindowx.h piwindowgen.h picontainerx.h \
+ $(INC)defs.h pigraphps.h pistdwdgx.h \
+ pistdwdggen.h piwindowx.h piwindowgen.h picontainerx.h \
  picontainergen.h pidrawer.h pidrwtools.h pioptmenux.h pioptmenugen.h \
  pimenux.h pimenugen.h piapplx.h piapplgen.h pimenubarx.h \
@@ -308,8 +281,6 @@
 $(OBJ)pistdwdgx.o: pistdwdgx.cc pisysdep.h pistdwdgx.h pistdwdggen.h \
  piwdgx.h piwdggen.h pimsghandler.h
-$(OBJ)pistlist.o: pistlist.cc pistlist.h \
- $(INC)stlist.h \
- $(INC)machine.h \
- $(INC)defs.h \
+$(OBJ)pistlist.o: pistlist.cc pistlist.h $(INC)stlist.h \
+ $(INC)machine.h $(INC)defs.h \
  $(INC)exceptions.h \
  $(INC)peidainit.h \
@@ -318,13 +289,9 @@
  $(INC)ppersist.h \
  $(INC)pclassids.h \
- $(INC)imaginit.h \
- $(INC)star.h \
+ $(INC)imaginit.h $(INC)star.h \
  $(INC)strecinit.h \
- $(INC)starmacro.h \
- $(INC)psf.h \
- $(INC)peida.h \
- $(INC)utils.h \
- $(INC)fmath.h \
- $(INC)cimage.h \
+ $(INC)starmacro.h $(INC)psf.h \
+ $(INC)peida.h $(INC)utils.h \
+ $(INC)fmath.h $(INC)cimage.h \
  $(INC)rzimage.h \
  $(INC)rzvect.h \
@@ -336,9 +303,7 @@
  $(INC)cvector.h \
  $(INC)generaldata.h \
- $(INC)poly.h \
- $(INC)fct2dfit.h \
+ $(INC)poly.h $(INC)fct2dfit.h \
  $(INC)pixelmap.h \
- $(INC)transfo.h \
- $(INC)zfidu.h \
+ $(INC)transfo.h $(INC)zfidu.h \
  $(INC)imgalig.h \
  $(INC)fitsimage.h \
@@ -355,31 +320,25 @@
  $(INC)erostarfile.h \
  $(INC)xstrstream.h \
- $(INC)dates.h \
- $(INC)tarlib.h pidrawer.h \
- pibwdggen.h pisysdep.h piwdgx.h piwdggen.h pimsghandler.h picmap.h \
- picmapx.h picmapgen.h pigraphx.h pigraphgen.h pigraphuc.h psfile.h
-$(OBJ)pistzwin.o: pistzwin.cc \
- pistzwin.h pisysdep.h piwindowx.h piwindowgen.h picontainerx.h \
- picontainergen.h piwdgx.h piwdggen.h pimsghandler.h piperiodx.h \
- $(INC)periodic.h \
- $(INC)defs.h psfile.h \
- pigraphgen.h picmap.h picmapx.h picmapgen.h
+ $(INC)dates.h $(INC)tarlib.h \
+ pidrawer.h pibwdggen.h pisysdep.h piwdgx.h piwdggen.h pimsghandler.h \
+ picmap.h picmapx.h picmapgen.h pigraphx.h pigraphgen.h pigraphuc.h \
+ psfile.h
+$(OBJ)pistzwin.o: pistzwin.cc pistzwin.h pisysdep.h piwindowx.h \
+ piwindowgen.h picontainerx.h picontainergen.h piwdgx.h piwdggen.h \
+ pimsghandler.h piperiodx.h $(INC)periodic.h \
+ $(INC)defs.h psfile.h pigraphgen.h picmap.h \
+ picmapx.h picmapgen.h
 $(OBJ)pisurfdr.o: pisurfdr.cc pisurfdr.h parradapter.h \
- $(INC)defs.h \
- $(INC)machine.h lut.h \
- pi3ddrw.h pisysdep.h pidrawer.h pibwdggen.h piwdgx.h piwdggen.h \
+ $(INC)defs.h $(INC)machine.h \
+ lut.h pi3ddrw.h pisysdep.h pidrawer.h pibwdggen.h piwdgx.h piwdggen.h \
  pimsghandler.h picmap.h picmapx.h picmapgen.h pigraphx.h pigraphgen.h \
  pigraphuc.h psfile.h pigraph3d.h pibwdgx.h pigraphps.h
-$(OBJ)piup.o: piup.cc \
- $(INC)ctimer.h \
- $(INC)peida.h \
- $(INC)defs.h \
- $(INC)utils.h \
- $(INC)machine.h \
- $(INC)perrors.h \
- $(INC)exceptions.h \
- $(INC)peidainit.h \
- $(INC)fmath.h \
- $(INC)imageop.h \
+$(OBJ)piup.o: piup.cc $(INC)ctimer.h \
+ $(INC)peida.h $(INC)defs.h \
+ $(INC)utils.h $(INC)machine.h \
+ $(INC)perrors.h \
+ $(INC)exceptions.h \
+ $(INC)peidainit.h \
+ $(INC)fmath.h $(INC)imageop.h \
  $(INC)cimage.h \
  $(INC)rzimage.h \
@@ -406,16 +365,15 @@
  $(INC)erostarfile.h \
  $(INC)xstrstream.h \
- $(INC)dates.h \
- $(INC)tarlib.h piup.h
+ $(INC)dates.h $(INC)tarlib.h \
+ piup.h
 $(OBJ)piwdggen.o: piwdggen.cc piwdggen.h pimsghandler.h picontainergen.h \
- pisysdep.h piwdgx.h psfile.h \
- $(INC)defs.h pigraphgen.h \
- picmap.h picmapx.h picmapgen.h
+ pisysdep.h piwdgx.h psfile.h $(INC)defs.h \
+ pigraphgen.h picmap.h picmapx.h picmapgen.h
 $(OBJ)piwdgx.o: piwdgx.cc piwdgx.h piwdggen.h pimsghandler.h picontainerx.h \
  pisysdep.h picontainergen.h
 $(OBJ)piwindowgen.o: piwindowgen.cc piwindowgen.h pisysdep.h picontainerx.h \
  picontainergen.h piwdgx.h piwdggen.h pimsghandler.h psfile.h \
- $(INC)defs.h pigraphgen.h \
- picmap.h picmapx.h picmapgen.h
+ $(INC)defs.h pigraphgen.h picmap.h picmapx.h \
+ picmapgen.h
 $(OBJ)piwindowx.o: piwindowx.cc piwindowx.h piwindowgen.h pisysdep.h \
  picontainerx.h picontainergen.h piwdgx.h piwdggen.h pimsghandler.h
@@ -423,8 +381,6 @@
  piwdgx.h piwdggen.h pimsghandler.h picmap.h picmapx.h picmapgen.h \
  pigraphx.h pigraphgen.h pigraphuc.h psfile.h \
- $(INC)defs.h pigraphps.h \
- pixtbase.h
-$(OBJ)psfile.o: psfile.cc psfile.h \
- $(INC)defs.h pisysdep.h \
- pigraphgen.h piwdgx.h piwdggen.h pimsghandler.h picmap.h picmapx.h \
- picmapgen.h
+ $(INC)defs.h pigraphps.h pixtbase.h
+$(OBJ)psfile.o: psfile.cc psfile.h $(INC)defs.h \
+ pisysdep.h pigraphgen.h piwdgx.h piwdggen.h pimsghandler.h picmap.h \
+ picmapx.h picmapgen.h