Index: /trunk/SophyaPI/PI/piinit.h
===================================================================
--- /trunk/SophyaPI/PI/piinit.h	(revision 161)
+++ /trunk/SophyaPI/PI/piinit.h	(revision 162)
@@ -10,6 +10,6 @@
   static int FgInit;
 public:
-  PeidaInteractiveInitiator();
- ~PeidaInteractiveInitiator();
+  		PeidaInteractiveInitiator();
+ virtual	~PeidaInteractiveInitiator();
 };
 
Index: /trunk/SophyaPI/PI/pipodrw.cc
===================================================================
--- /trunk/SophyaPI/PI/pipodrw.cc	(revision 161)
+++ /trunk/SophyaPI/PI/pipodrw.cc	(revision 162)
@@ -6,37 +6,4 @@
 #include "generalfit.h"
 
-//================================================================
-// PIFuncDrawer
-//================================================================
-
-PIFuncDrawer::PIFuncDrawer(PIFuncDrawer::FUNC f)
-: mFunc(f)
-{}
-
-PIFuncDrawer::~PIFuncDrawer()
-{
-}
-
-void
-PIFuncDrawer::Draw(PIGraphicUC* g, float /*xmin*/, float/*ymin*/, float/*xmax*/, float/*ymax*/)
-{
-  PIGrCoord x1, x2, y1, y2;
-  g->GetGrSpace(x1, x2, y1, y2);
-  float xMax = x2;
-  float xMin = x1;
-  float yMax = y2;
-  float yMin = y1;
-  float xStep = (xMax - xMin)/100;
-  float xOld = xMin;
-  float yOld = mFunc(xMin);
-  for (float x = xMin+xStep; x<xMax; x+=xStep) {
-    double y = mFunc(x);
-    if (y>yMin && yOld>yMin && 
-        y<yMax && yOld<yMax) 
-           g->DrawLine(xOld, yOld, x, y);
-    xOld = x;
-    yOld = y;
-  }
-}
 
 //================================================================
Index: /trunk/SophyaPI/PI/pipodrw.h
===================================================================
--- /trunk/SophyaPI/PI/pipodrw.h	(revision 161)
+++ /trunk/SophyaPI/PI/pipodrw.h	(revision 162)
@@ -13,14 +13,4 @@
 #include "histos2.h"
 
-class PIFuncDrawer : public PIDrawer {
-public:
-  typedef double(*FUNC)(double);
-                     PIFuncDrawer(FUNC);
-  virtual           ~PIFuncDrawer();
-  
-  virtual void       Draw(PIGraphicUC* g, float xmin, float ymin, float xmax, float ymax);
-protected:
-  FUNC               mFunc;
-};
 
 class GeneralFunction;
Index: /trunk/SophyaPI/PI/piscdrawwdg.cc
===================================================================
--- /trunk/SophyaPI/PI/piscdrawwdg.cc	(revision 161)
+++ /trunk/SophyaPI/PI/piscdrawwdg.cc	(revision 162)
@@ -343,2 +343,41 @@
   }
 }
+
+
+//================================================================
+// PIFuncDrawer
+// Classe de traceur de fonction  double = f(fouble)
+//================================================================
+
+/* --Methode-- */
+PIFuncDrawer::PIFuncDrawer(PIFuncDrawer::FUNC f)
+: mFunc(f)
+{}
+
+/* --Methode-- */
+PIFuncDrawer::~PIFuncDrawer()
+{
+}
+
+/* --Methode-- */
+void
+PIFuncDrawer::Draw(PIGraphicUC* g, float /*xmin*/, float/*ymin*/, float/*xmax*/, float/*ymax*/)
+{
+  PIGrCoord x1, x2, y1, y2;
+  g->GetGrSpace(x1, x2, y1, y2);
+  float xMax = x2;
+  float xMin = x1;
+  float yMax = y2;
+  float yMin = y1;
+  float xStep = (xMax - xMin)/100;
+  float xOld = xMin;
+  float yOld = mFunc(xMin);
+  for (float x = xMin+xStep; x<xMax; x+=xStep) {
+    double y = mFunc(x);
+    if (y>yMin && yOld>yMin && 
+        y<yMax && yOld<yMax) 
+           g->DrawLine(xOld, yOld, x, y);
+    xOld = x;
+    yOld = y;
+  }
+}
Index: /trunk/SophyaPI/PI/piscdrawwdg.h
===================================================================
--- /trunk/SophyaPI/PI/piscdrawwdg.h	(revision 161)
+++ /trunk/SophyaPI/PI/piscdrawwdg.h	(revision 162)
@@ -108,3 +108,18 @@
 };
 
+// ----------------------------------------------------------
+// Classe de traceur de fonction  double = f(fouble)
+// ----------------------------------------------------------
+
+class PIFuncDrawer : public PIDrawer {
+public:
+  typedef double(*FUNC)(double);
+                     PIFuncDrawer(FUNC);
+  virtual           ~PIFuncDrawer();
+  
+  virtual void       Draw(PIGraphicUC* g, float xmin, float ymin, float xmax, float ymax);
+protected:
+  FUNC               mFunc;
+};
+
 #endif